WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Public Attributes | Protected Member Functions | List of all members
winstd::sec_context Class Reference
Security API

PCtxtHandle wrapper class. More...

`#include <Sec.h>`

Inheritance diagram for winstd::sec_context:

## Public Member Functions
| sec_context ()
| Initializes a new class instance with the object handle set to NULL.
| sec_context (_Inout_ sec_context &&h) noexcept
| Move constructor. More...
virtual | ~sec_context ()
| Frees the security context. More...
sec_context & | operator= (_Inout_ sec_context &&h) noexcept
| Move assignment. More...
SECURITY_STATUS | initialize (_In_opt_ PCredHandle phCredential, _In_opt_z_ LPCTSTR pszTargetName, _In_ ULONG fContextReq, _In_ ULONG TargetDataRep, _In_opt_ PSecBufferDesc pInput, _Inout_opt_ PSecBufferDesc pOutput)
| Initializes security context. More...
SECURITY_STATUS | process (_In_opt_ PCredHandle phCredential, _In_opt_z_ LPCTSTR pszTargetName, _In_ ULONG fContextReq, _In_ ULONG TargetDataRep, _In_opt_ PSecBufferDesc pInput, _Inout_opt_ PSecBufferDesc pOutput)
| Continue security context. More...
Public Member Functions inherited from winstd::handle< PCtxtHandle, NULL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Public Attributes
ULONG | m_attrib
| Context attributes.
TimeStamp | m_expires
| Context expiration time.

## Protected Member Functions
void | free_internal () noexcept override
| Frees the security context. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members
Public Types inherited from winstd::handle< PCtxtHandle, NULL >
typedef PCtxtHandle | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< PCtxtHandle, NULL >
static const PCtxtHandle | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< PCtxtHandle, NULL >
handle_type | m_h
| Object handle.

## Detailed Description

PCtxtHandle wrapper class.

## Constructor & Destructor Documentation

## ◆ sec_context()

winstd::sec_context::sec_context | ( | _Inout_ sec_context && | h | ) |
| inline noexcept

Move constructor.

Parameters

  [in,out] | h | A rvalue reference of another object

## ◆ ~sec_context()

virtual winstd::sec_context::~sec_context | ( |  | ) |
| inline virtual

Frees the security context.

See also
  DeleteSecurityContext function

## Member Function Documentation

## ◆ free_internal()

void winstd::sec_context::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Frees the security context.

See also
  DeleteSecurityContext function

Implements winstd::handle< PCtxtHandle, NULL >.

## ◆ initialize()

SECURITY_STATUS winstd::sec_context::initialize | ( | _In_opt_ PCredHandle | phCredential,
|  | _In_opt_z_ LPCTSTR | pszTargetName,
|  | _In_ ULONG | fContextReq,
|  | _In_ ULONG | TargetDataRep,
|  | _In_opt_ PSecBufferDesc | pInput,
|  | _Inout_opt_ PSecBufferDesc | pOutput
| ) |  |
| inline

Initializes security context.

Returns
  - `SEC_E_OK` when succeeds;
  - Error code when fails.

See also
  InitializeSecurityContext (General) function

## ◆ operator=()

sec_context & winstd::sec_context::operator= | ( | _Inout_ sec_context && | h | ) |
| inline noexcept

Move assignment.

Parameters

  [in,out] | h | A rvalue reference of another object

## ◆ process()

SECURITY_STATUS winstd::sec_context::process | ( | _In_opt_ PCredHandle | phCredential,
|  | _In_opt_z_ LPCTSTR | pszTargetName,
|  | _In_ ULONG | fContextReq,
|  | _In_ ULONG | TargetDataRep,
|  | _In_opt_ PSecBufferDesc | pInput,
|  | _Inout_opt_ PSecBufferDesc | pOutput
| ) |  |
| inline

Continue security context.

Returns
  - `SEC_E_OK` when succeeds;
  - Error code when fails.

See also
  InitializeSecurityContext (General) function

The documentation for this class was generated from the following file:

- include/WinStd/Sec.h